class Stack[A] {
    import java.util.{ArrayList => JArrayList};
    private var stack = new JArrayList[A];

    //Retourne vrai si la pile est vide
    def isEmpty: Boolean = stack.isEmpty

    // Retourne le nombre d'éléments de la pile
    def size: Int = stack.size

    // Empile un élément sur la pile
    def push( a: A ): Unit = stack.add(0, a)

    // Dépile et retourne le sommet de la pile
    def pop: A = {
        if (stack.isEmpty) {
            throw new Exception
        } else {
            stack.get(0)
            stack.remove(0)
        }
    }

    //Inverse les deux éléments au sommet de la pile
    //ne fait rien si moins de deux éléments
    def swap: Unit = {
        if (stack.size >= 2) {
            val v = pop
            stack.add(1, v)
        }
    }
}

object Stack extends App {
    println("Stack testing...")
    var s = new Stack[Int]
    assert(s.isEmpty)
    assert(s.size == 0)
    s.push(1)
    assert(s.pop == 1)
    s.push(1)
    s.push(2)
    s.push(3)
    assert(s.size == 3)
    assert(!s.isEmpty)
    assert(s.pop == 3)
    s.swap
    assert(s.pop == 1)
    assert(s.pop == 2)
    println("Stack tested !")
}